=begin
#Spinnaker API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

require 'uri'

module SwaggerClient
  class ConcourseControllerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Retrieve the list of job names for a given pipeline available to triggers
    # @param build_master buildMaster
    # @param team team
    # @param pipeline pipeline
    # @param [Hash] opts the optional parameters
    # @return [Array<Object>]
    def jobs_using_get(build_master, team, pipeline, opts = {})
      data, _status_code, _headers = jobs_using_get_with_http_info(build_master, team, pipeline, opts)
      data
    end

    # Retrieve the list of job names for a given pipeline available to triggers
    # @param build_master buildMaster
    # @param team team
    # @param pipeline pipeline
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def jobs_using_get_with_http_info(build_master, team, pipeline, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConcourseControllerApi.jobs_using_get ...'
      end
      # verify the required parameter 'build_master' is set
      if @api_client.config.client_side_validation && build_master.nil?
        fail ArgumentError, "Missing the required parameter 'build_master' when calling ConcourseControllerApi.jobs_using_get"
      end
      # verify the required parameter 'team' is set
      if @api_client.config.client_side_validation && team.nil?
        fail ArgumentError, "Missing the required parameter 'team' when calling ConcourseControllerApi.jobs_using_get"
      end
      # verify the required parameter 'pipeline' is set
      if @api_client.config.client_side_validation && pipeline.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline' when calling ConcourseControllerApi.jobs_using_get"
      end
      # resource path
      local_var_path = '/concourse/{buildMaster}/teams/{team}/pipelines/{pipeline}/jobs'.sub('{' + 'buildMaster' + '}', build_master.to_s).sub('{' + 'team' + '}', team.to_s).sub('{' + 'pipeline' + '}', pipeline.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConcourseControllerApi#jobs_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve the list of pipeline names for a given team available to triggers
    # @param build_master buildMaster
    # @param team team
    # @param [Hash] opts the optional parameters
    # @return [Array<Object>]
    def pipelines_using_get(build_master, team, opts = {})
      data, _status_code, _headers = pipelines_using_get_with_http_info(build_master, team, opts)
      data
    end

    # Retrieve the list of pipeline names for a given team available to triggers
    # @param build_master buildMaster
    # @param team team
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def pipelines_using_get_with_http_info(build_master, team, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConcourseControllerApi.pipelines_using_get ...'
      end
      # verify the required parameter 'build_master' is set
      if @api_client.config.client_side_validation && build_master.nil?
        fail ArgumentError, "Missing the required parameter 'build_master' when calling ConcourseControllerApi.pipelines_using_get"
      end
      # verify the required parameter 'team' is set
      if @api_client.config.client_side_validation && team.nil?
        fail ArgumentError, "Missing the required parameter 'team' when calling ConcourseControllerApi.pipelines_using_get"
      end
      # resource path
      local_var_path = '/concourse/{buildMaster}/teams/{team}/pipelines'.sub('{' + 'buildMaster' + '}', build_master.to_s).sub('{' + 'team' + '}', team.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConcourseControllerApi#pipelines_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve the list of resource names for a given pipeline available to the Concourse stage
    # @param build_master buildMaster
    # @param team team
    # @param pipeline pipeline
    # @param [Hash] opts the optional parameters
    # @return [Array<Object>]
    def resources_using_get(build_master, team, pipeline, opts = {})
      data, _status_code, _headers = resources_using_get_with_http_info(build_master, team, pipeline, opts)
      data
    end

    # Retrieve the list of resource names for a given pipeline available to the Concourse stage
    # @param build_master buildMaster
    # @param team team
    # @param pipeline pipeline
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def resources_using_get_with_http_info(build_master, team, pipeline, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ConcourseControllerApi.resources_using_get ...'
      end
      # verify the required parameter 'build_master' is set
      if @api_client.config.client_side_validation && build_master.nil?
        fail ArgumentError, "Missing the required parameter 'build_master' when calling ConcourseControllerApi.resources_using_get"
      end
      # verify the required parameter 'team' is set
      if @api_client.config.client_side_validation && team.nil?
        fail ArgumentError, "Missing the required parameter 'team' when calling ConcourseControllerApi.resources_using_get"
      end
      # verify the required parameter 'pipeline' is set
      if @api_client.config.client_side_validation && pipeline.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline' when calling ConcourseControllerApi.resources_using_get"
      end
      # resource path
      local_var_path = '/concourse/{buildMaster}/teams/{team}/pipelines/{pipeline}/resources'.sub('{' + 'buildMaster' + '}', build_master.to_s).sub('{' + 'team' + '}', team.to_s).sub('{' + 'pipeline' + '}', pipeline.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ConcourseControllerApi#resources_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
