=begin
#Spinnaker API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

require 'uri'

module SwaggerClient
  class InstanceControllerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Retrieve an instance's console output
    # @param account account
    # @param region region
    # @param instance_id instanceId
    # @param [Hash] opts the optional parameters
    # @option opts [String] :provider provider (default to aws)
    # @option opts [String] :x_rate_limit_app X-RateLimit-App
    # @return [Object]
    def get_console_output_using_get(account, region, instance_id, opts = {})
      data, _status_code, _headers = get_console_output_using_get_with_http_info(account, region, instance_id, opts)
      data
    end

    # Retrieve an instance&#39;s console output
    # @param account account
    # @param region region
    # @param instance_id instanceId
    # @param [Hash] opts the optional parameters
    # @option opts [String] :provider provider
    # @option opts [String] :x_rate_limit_app X-RateLimit-App
    # @return [Array<(Object, Fixnum, Hash)>] Object data, response status code and response headers
    def get_console_output_using_get_with_http_info(account, region, instance_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstanceControllerApi.get_console_output_using_get ...'
      end
      # verify the required parameter 'account' is set
      if @api_client.config.client_side_validation && account.nil?
        fail ArgumentError, "Missing the required parameter 'account' when calling InstanceControllerApi.get_console_output_using_get"
      end
      # verify the required parameter 'region' is set
      if @api_client.config.client_side_validation && region.nil?
        fail ArgumentError, "Missing the required parameter 'region' when calling InstanceControllerApi.get_console_output_using_get"
      end
      # verify the required parameter 'instance_id' is set
      if @api_client.config.client_side_validation && instance_id.nil?
        fail ArgumentError, "Missing the required parameter 'instance_id' when calling InstanceControllerApi.get_console_output_using_get"
      end
      # resource path
      local_var_path = '/instances/{account}/{region}/{instanceId}/console'.sub('{' + 'account' + '}', account.to_s).sub('{' + 'region' + '}', region.to_s).sub('{' + 'instanceId' + '}', instance_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'provider'] = opts[:'provider'] if !opts[:'provider'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-RateLimit-App'] = opts[:'x_rate_limit_app'] if !opts[:'x_rate_limit_app'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Object')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstanceControllerApi#get_console_output_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve an instance's details
    # @param account account
    # @param region region
    # @param instance_id instanceId
    # @param [Hash] opts the optional parameters
    # @option opts [String] :x_rate_limit_app X-RateLimit-App
    # @return [Object]
    def get_instance_details_using_get(account, region, instance_id, opts = {})
      data, _status_code, _headers = get_instance_details_using_get_with_http_info(account, region, instance_id, opts)
      data
    end

    # Retrieve an instance&#39;s details
    # @param account account
    # @param region region
    # @param instance_id instanceId
    # @param [Hash] opts the optional parameters
    # @option opts [String] :x_rate_limit_app X-RateLimit-App
    # @return [Array<(Object, Fixnum, Hash)>] Object data, response status code and response headers
    def get_instance_details_using_get_with_http_info(account, region, instance_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: InstanceControllerApi.get_instance_details_using_get ...'
      end
      # verify the required parameter 'account' is set
      if @api_client.config.client_side_validation && account.nil?
        fail ArgumentError, "Missing the required parameter 'account' when calling InstanceControllerApi.get_instance_details_using_get"
      end
      # verify the required parameter 'region' is set
      if @api_client.config.client_side_validation && region.nil?
        fail ArgumentError, "Missing the required parameter 'region' when calling InstanceControllerApi.get_instance_details_using_get"
      end
      # verify the required parameter 'instance_id' is set
      if @api_client.config.client_side_validation && instance_id.nil?
        fail ArgumentError, "Missing the required parameter 'instance_id' when calling InstanceControllerApi.get_instance_details_using_get"
      end
      # resource path
      local_var_path = '/instances/{account}/{region}/{instanceId}'.sub('{' + 'account' + '}', account.to_s).sub('{' + 'region' + '}', region.to_s).sub('{' + 'instanceId' + '}', instance_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-RateLimit-App'] = opts[:'x_rate_limit_app'] if !opts[:'x_rate_limit_app'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Object')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InstanceControllerApi#get_instance_details_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
