=begin
#Spinnaker API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

require 'uri'

module SwaggerClient
  class PipelineConfigControllerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Convert a pipeline config to a pipeline template.
    # @param pipeline_config_id pipelineConfigId
    # @param [Hash] opts the optional parameters
    # @return [String]
    def convert_pipeline_config_to_pipeline_template_using_get(pipeline_config_id, opts = {})
      data, _status_code, _headers = convert_pipeline_config_to_pipeline_template_using_get_with_http_info(pipeline_config_id, opts)
      data
    end

    # Convert a pipeline config to a pipeline template.
    # @param pipeline_config_id pipelineConfigId
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def convert_pipeline_config_to_pipeline_template_using_get_with_http_info(pipeline_config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PipelineConfigControllerApi.convert_pipeline_config_to_pipeline_template_using_get ...'
      end
      # verify the required parameter 'pipeline_config_id' is set
      if @api_client.config.client_side_validation && pipeline_config_id.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline_config_id' when calling PipelineConfigControllerApi.convert_pipeline_config_to_pipeline_template_using_get"
      end
      # resource path
      local_var_path = '/pipelineConfigs/{pipelineConfigId}/convertToTemplate'.sub('{' + 'pipelineConfigId' + '}', pipeline_config_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PipelineConfigControllerApi#convert_pipeline_config_to_pipeline_template_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get all pipeline configs.
    # @param [Hash] opts the optional parameters
    # @return [Array<Object>]
    def get_all_pipeline_configs_using_get(opts = {})
      data, _status_code, _headers = get_all_pipeline_configs_using_get_with_http_info(opts)
      data
    end

    # Get all pipeline configs.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def get_all_pipeline_configs_using_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PipelineConfigControllerApi.get_all_pipeline_configs_using_get ...'
      end
      # resource path
      local_var_path = '/pipelineConfigs'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PipelineConfigControllerApi#get_all_pipeline_configs_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get pipeline config history.
    # @param pipeline_config_id pipelineConfigId
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit limit (default to 20)
    # @return [Array<Object>]
    def get_pipeline_config_history_using_get(pipeline_config_id, opts = {})
      data, _status_code, _headers = get_pipeline_config_history_using_get_with_http_info(pipeline_config_id, opts)
      data
    end

    # Get pipeline config history.
    # @param pipeline_config_id pipelineConfigId
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit limit
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def get_pipeline_config_history_using_get_with_http_info(pipeline_config_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PipelineConfigControllerApi.get_pipeline_config_history_using_get ...'
      end
      # verify the required parameter 'pipeline_config_id' is set
      if @api_client.config.client_side_validation && pipeline_config_id.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline_config_id' when calling PipelineConfigControllerApi.get_pipeline_config_history_using_get"
      end
      # resource path
      local_var_path = '/pipelineConfigs/{pipelineConfigId}/history'.sub('{' + 'pipelineConfigId' + '}', pipeline_config_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PipelineConfigControllerApi#get_pipeline_config_history_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
