=begin
#Spinnaker API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

require 'uri'

module SwaggerClient
  class SearchControllerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Search infrastructure
    # @param type type
    # @param [Hash] opts the optional parameters
    # @option opts [String] :q q
    # @option opts [String] :platform platform
    # @option opts [Integer] :page_size pageSize (default to 10000)
    # @option opts [Integer] :page page (default to 1)
    # @option opts [BOOLEAN] :allow_short_query allowShortQuery (default to false)
    # @option opts [String] :x_rate_limit_app X-RateLimit-App
    # @return [Array<Object>]
    def search_using_get(type, opts = {})
      data, _status_code, _headers = search_using_get_with_http_info(type, opts)
      data
    end

    # Search infrastructure
    # @param type type
    # @param [Hash] opts the optional parameters
    # @option opts [String] :q q
    # @option opts [String] :platform platform
    # @option opts [Integer] :page_size pageSize
    # @option opts [Integer] :page page
    # @option opts [BOOLEAN] :allow_short_query allowShortQuery
    # @option opts [String] :x_rate_limit_app X-RateLimit-App
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def search_using_get_with_http_info(type, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: SearchControllerApi.search_using_get ...'
      end
      # verify the required parameter 'type' is set
      if @api_client.config.client_side_validation && type.nil?
        fail ArgumentError, "Missing the required parameter 'type' when calling SearchControllerApi.search_using_get"
      end
      # resource path
      local_var_path = '/search'

      # query parameters
      query_params = {}
      query_params[:'type'] = type
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'platform'] = opts[:'platform'] if !opts[:'platform'].nil?
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'allowShortQuery'] = opts[:'allow_short_query'] if !opts[:'allow_short_query'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-RateLimit-App'] = opts[:'x_rate_limit_app'] if !opts[:'x_rate_limit_app'].nil?

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: SearchControllerApi#search_using_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
