=begin
#Spinnaker API

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

require 'uri'

module SwaggerClient
  class V2PipelineTemplatesControllerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # (ALPHA) Create a pipeline template.
    # @param pipeline_template pipelineTemplate
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @return [nil]
    def create_using_post1(pipeline_template, opts = {})
      create_using_post1_with_http_info(pipeline_template, opts)
      nil
    end

    # (ALPHA) Create a pipeline template.
    # @param pipeline_template pipelineTemplate
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def create_using_post1_with_http_info(pipeline_template, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.create_using_post1 ...'
      end
      # verify the required parameter 'pipeline_template' is set
      if @api_client.config.client_side_validation && pipeline_template.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline_template' when calling V2PipelineTemplatesControllerApi.create_using_post1"
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates/create'

      # query parameters
      query_params = {}
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(pipeline_template)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#create_using_post1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a pipeline template.
    # @param id id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @option opts [String] :digest digest
    # @option opts [String] :application application
    # @return [Hash<String, Object>]
    def delete_using_delete1(id, opts = {})
      data, _status_code, _headers = delete_using_delete1_with_http_info(id, opts)
      data
    end

    # Delete a pipeline template.
    # @param id id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @option opts [String] :digest digest
    # @option opts [String] :application application
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def delete_using_delete1_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.delete_using_delete1 ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling V2PipelineTemplatesControllerApi.delete_using_delete1"
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?
      query_params[:'digest'] = opts[:'digest'] if !opts[:'digest'].nil?
      query_params[:'application'] = opts[:'application'] if !opts[:'application'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#delete_using_delete1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # (ALPHA) Get a pipeline template.
    # @param id id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @option opts [String] :digest digest
    # @return [Hash<String, Object>]
    def get_using_get2(id, opts = {})
      data, _status_code, _headers = get_using_get2_with_http_info(id, opts)
      data
    end

    # (ALPHA) Get a pipeline template.
    # @param id id
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @option opts [String] :digest digest
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def get_using_get2_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.get_using_get2 ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling V2PipelineTemplatesControllerApi.get_using_get2"
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?
      query_params[:'digest'] = opts[:'digest'] if !opts[:'digest'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#get_using_get2\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # (ALPHA) List all pipelines that implement a pipeline template
    # @param id id
    # @param [Hash] opts the optional parameters
    # @return [Array<Object>]
    def list_pipeline_template_dependents_using_get1(id, opts = {})
      data, _status_code, _headers = list_pipeline_template_dependents_using_get1_with_http_info(id, opts)
      data
    end

    # (ALPHA) List all pipelines that implement a pipeline template
    # @param id id
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def list_pipeline_template_dependents_using_get1_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.list_pipeline_template_dependents_using_get1 ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling V2PipelineTemplatesControllerApi.list_pipeline_template_dependents_using_get1"
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates/{id}/dependents'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#list_pipeline_template_dependents_using_get1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # (ALPHA) List pipeline templates.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :scopes scopes
    # @return [Array<Object>]
    def list_using_get1(opts = {})
      data, _status_code, _headers = list_using_get1_with_http_info(opts)
      data
    end

    # (ALPHA) List pipeline templates.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :scopes scopes
    # @return [Array<(Array<Object>, Fixnum, Hash)>] Array<Object> data, response status code and response headers
    def list_using_get1_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.list_using_get1 ...'
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates'

      # query parameters
      query_params = {}
      query_params[:'scopes'] = @api_client.build_collection_param(opts[:'scopes'], :multi) if !opts[:'scopes'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = []
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#list_using_get1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # (ALPHA) Plan a pipeline template configuration.
    # @param pipeline pipeline
    # @param [Hash] opts the optional parameters
    # @return [Hash<String, Object>]
    def plan_using_post(pipeline, opts = {})
      data, _status_code, _headers = plan_using_post_with_http_info(pipeline, opts)
      data
    end

    # (ALPHA) Plan a pipeline template configuration.
    # @param pipeline pipeline
    # @param [Hash] opts the optional parameters
    # @return [Array<(Hash<String, Object>, Fixnum, Hash)>] Hash<String, Object> data, response status code and response headers
    def plan_using_post_with_http_info(pipeline, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.plan_using_post ...'
      end
      # verify the required parameter 'pipeline' is set
      if @api_client.config.client_side_validation && pipeline.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline' when calling V2PipelineTemplatesControllerApi.plan_using_post"
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates/plan'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(pipeline)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Hash<String, Object>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#plan_using_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # (ALPHA) Update a pipeline template.
    # @param id id
    # @param pipeline_template pipelineTemplate
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @option opts [BOOLEAN] :skip_plan_dependents skipPlanDependents (default to false)
    # @return [nil]
    def update_using_post1(id, pipeline_template, opts = {})
      update_using_post1_with_http_info(id, pipeline_template, opts)
      nil
    end

    # (ALPHA) Update a pipeline template.
    # @param id id
    # @param pipeline_template pipelineTemplate
    # @param [Hash] opts the optional parameters
    # @option opts [String] :tag tag
    # @option opts [BOOLEAN] :skip_plan_dependents skipPlanDependents
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def update_using_post1_with_http_info(id, pipeline_template, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: V2PipelineTemplatesControllerApi.update_using_post1 ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling V2PipelineTemplatesControllerApi.update_using_post1"
      end
      # verify the required parameter 'pipeline_template' is set
      if @api_client.config.client_side_validation && pipeline_template.nil?
        fail ArgumentError, "Missing the required parameter 'pipeline_template' when calling V2PipelineTemplatesControllerApi.update_using_post1"
      end
      # resource path
      local_var_path = '/v2/pipelineTemplates/update/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?
      query_params[:'skipPlanDependents'] = opts[:'skip_plan_dependents'] if !opts[:'skip_plan_dependents'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['*/*'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(pipeline_template)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: V2PipelineTemplatesControllerApi#update_using_post1\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
